routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::match(['get', 'post'], '/', 'LeadController@index')->middleware('auth');
Route::get('logout', function () {
    Auth::logout();
    return redirect('/');
});

Route::match(['get', 'post'], 'lead/import', 'LeadController@import')->name('lead.import')->middleware('auth');
Route::get('lead/export', 'LeadController@export')->middleware('auth');;
Route::match(['get', 'post'], 'lead/list', 'LeadController@search')->middleware('auth');
Route::match(['get', 'post'], 'account/list', 'AccountController@listAll')->middleware('auth');
Route::get('lead/edit/{id}', 'LeadController@edit')->middleware('auth');
Route::post('lead/assign', 'LeadController@assignLead')->name('lead.assign');
Route::get('import', 'FileImportController@index')->middleware('auth');
Route::get('importSuspectHistory', 'SuspectFileImportController@index')->middleware('auth');
Route::get('province', 'ProvinceController@index')->middleware('auth');
Route::get('lead/edit/{id}', 'LeadController@edit')->middleware('auth');
Route::get('lead/clearFilters', 'LeadController@clearFiltering')->name('lead.clearFilters')->middleware('auth');
Route::resource('user', 'UserController');

Route::match(['get', 'post'], 'user/create', 'UserController@create')->name('user.create')->middleware('auth');
Route::match(['get', 'post'], 'user/changepassword', 'UserController@changePassword')->name('user.changepassword')->middleware('auth');
Route::match(['get', 'post'], 'user/{id?}/resetpassword', 'UserController@resetPassword')->name('user.resetpassword')->middleware('auth');
Route::match(['get', 'post'], 'user/{user_id}/loginAs', 'UserController@loginAs')->name('user.loginAs')->middleware('auth');
Route::match(['get', 'post'], 'notification', 'UserController@getNotifications')->name('user.notification')->middleware('auth');
Route::match(['get', 'post'], 'user/logout', 'UserController@logout')->name('user.logout')->middleware('auth');
Route::resource('lead', 'LeadController');
Route::match(['get', 'post'], 'lead/export', 'LeadController@export')->name('lead.export')->middleware('auth');
Route::resource('account', 'AccountController');
Route::resource('group', 'GroupController');
Route::match(['get', 'post'], 'email-list/{id}/import', 'EmailMarketing\EmailListController@import')->name('email-list.import');
Route::match(['get', 'post'], 'email-campaign/{id}/import', 'EmailMarketing\EmailCampaignController@import')->name('email-campaign.import');
Route::get('email-list/{id}/export', 'EmailMarketing\EmailListController@export')->name('email-list.export');
Route::resource('email-list', 'EmailMarketing\EmailListController');
Route::get('email-campaign/{id}/showPdf', 'EmailMarketing\EmailCampaignController@showPdf')->name('email-campaign.showPdf');
Route::get('email-campaign/{id}/genPdf', 'EmailMarketing\EmailCampaignController@genPdf')->name('email-campaign.genPdf');
Route::get('email-campaign/{id}/regenAllPdf', 'EmailMarketing\EmailCampaignController@regenAllPdf')->name('email-campaign.regenAllPdf');
Route::get('email-campaign/{id}/genAllPdf', 'EmailMarketing\EmailCampaignController@genAllPdf')->name('email-campaign.genAllPdf');
Route::match(['get', 'post'], 'email-template/{id}/edit', 'EmailMarketing\EmailCampaignController@editEmailTemplate')->name('email-template.edit');
Route::resource('email-template', 'EmailMarketing\EmailTemplateController');
Route::get('email-campaign/{id}/showEmail', 'EmailMarketing\EmailCampaignController@showEmail')->name('email-campaign.showEmail');
Route::get('email-campaign/{id}/sendEmail', 'EmailMarketing\EmailCampaignController@sendEmail')->name('email.send');
Route::get('email-campaign/{id}/resend', 'EmailMarketing\EmailCampaignController@resend')->name('email.resend');
Route::get('email-campaign/{id}/sendTestEmail', 'EmailMarketing\EmailCampaignController@sendTestEmail')->name('email.sendTestEmail');
Route::get('email-campaign/{id}/progress', 'EmailMarketing\EmailCampaignController@progress')->name('email.progress');
Route::get('email-campaign/{id}/sendPrivateEmail', 'EmailMarketing\EmailCampaignController@sendPrivateEmail')->name('email.sendPrivate');
Route::resource('email-campaign', 'EmailMarketing\EmailCampaignController');
//Route::post('lead/{data?}', 'LeadController@index');
Route::match(['get', 'post'], 'lead/import', 'LeadController@import')->middleware('auth');

$s = 'social.';
Route::get('/social/redirect/{provider}', ['as' => $s . 'redirect', 'uses' => 'Auth\SocialController@getSocialRedirect']);
Route::get('/social/handle/{provider}', ['as' => $s . 'handle', 'uses' => 'Auth\SocialController@getSocialHandle']);

Route::get('ami', 'AsteriskController@call');
Auth::routes();

Route::get('/home', 'LeadController@index')->middleware('auth');
Route::get('/lead/index', 'LeadController@index')->middleware('auth');
Route::get('/report/campaign', 'ReportController@campaign')->name('report.campaign')->middleware('auth');
Route::get('/test', 'TestController@test')->name('test.test');
Route::get('/parse', 'TestController@parse_grade')->name('test.parse');
Route::get('/authorize', 'TestController@authorizeGoogle')->name('test.authorize');
Route::get('/report/online', 'ReportController@showOnlineStatus')->name('report.online')->middleware('auth');
Route::match(['get', 'post'], '/report/call_summary', 'ReportController@showCallSummaryReport')->name('report.call_summary')->middleware('auth');
Route::match(['get', 'post'], '/report/dmr', 'ReportController@showDmrReport')->name('report.dmr')->middleware('auth');
Route::get('/report/performance', 'ReportController@performance')->name('report.performance')->middleware('auth');
Route::match(['get', 'post'], '/report/lead', 'ReportController@showLeadReport')->name('report.lead')->middleware('auth');
Route::get('/utils/getSchools/{province}', 'UtilsController@getSchools');
Route::get('/utils/getSchools/{province}/{selected}', 'UtilsController@getSchools');
Route::get('/utils/getDistricts/{province}', 'UtilsController@getDistricts');
Route::get('/utils/getDistricts/{province}/{selected}', 'UtilsController@getDistricts');
Route::get('/utils/checkIfPhoneExists/{phone}', 'UtilsController@checkIfPhoneExists');
Route::get('/utils/getOnline/{user_id}', 'UtilsController@getOnline');
Route::get('/utils/getWeight', 'UtilsController@getWeight');
Route::get('/utils/getLeadCost', 'UtilsController@getLeadCost');
Route::get('/utils/checkCost', 'UtilsController@checkCost');
Route::get('/utils/checkList', 'UtilsController@checkList');
Route::get('/utils/getOnlineUsers', 'UtilsController@getOnlineUsers');
Route::get('/utils/fixAssignment', 'UtilsController@fix_assignment');
Route::get('/utils/setOnline/{user_id}', 'UtilsController@setOnline');
Route::get('/call/{phone}/{trunk?}', 'LeadController@call')->name('lead.call')->middleware('auth');
Route::get('/call_test/{phone}/{trunk?}', 'LeadController@call_test')->name('lead.call_test')->middleware('auth');
Route::get('/utils/getOnlineStatus/{user_id}', 'UtilsController@getOnlineStatus');
Route::match(['get', 'post'], '/sms/send', 'UtilsController@sendSms');
Route::resource('cost', 'MarketingCostController');
Route::resource('alarm', 'AlarmController');
Route::resource('cdr', 'CdrController');
Route::resource('class', 'AvailableClassController');
Route::get('class/{id}/toggle', 'AvailableClassController@toggle')->name('class.toggle')->middleware('auth');
Route::resource('source', 'SourceController');
Route::get('lead_status/{id}/toggle', 'LeadStatusController@toggle')->name('lead_status.toggle')->middleware('auth');
Route::resource('lead_status', 'LeadStatusController');
Route::get('call_status/{id}/toggle', 'CallStatusController@toggle')->name('call_status.toggle')->middleware('auth');
Route::resource('call_status', 'CallStatusController');
Route::get('source/{id}/toggle', 'SourceController@toggle')->name('source.toggle')->middleware('auth');
Route::resource('info_source', 'InfoSourceController');
Route::get('info_source/{id}/toggle', 'InfoSourceController@toggle')->name('info_source.toggle')->middleware('auth');
Route::resource('channel', 'ChannelController');
Route::get('channel/{id}/toggle', 'ChannelController@toggle')->name('channel.toggle')->middleware('auth');
Route::resource('campaign', 'CampaignController');
Route::get('campaign/{id}/toggle', 'CampaignController@toggle')->name('campaign.toggle')->middleware('auth');
Route::resource('campus', 'CampusController');
Route::get('campus/{id}/toggle', 'CampusController@toggle')->name('campus.toggle')->middleware('auth');
Route::resource('department', 'DepartmentController');
Route::get('department/{id}/toggle', 'DepartmentController@toggle')->name('department.toggle')->middleware('auth');
Route::resource('school', 'SchoolController');
Route::get('school/{id}/toggle', 'SchoolController@toggle')->name('school.toggle')->middleware('auth');
Route::resource('promotion', 'PromotionController');
Route::get('promotion/{id}/toggle', 'PromotionController@toggle')->name('promotion.toggle')->middleware('auth');
Route::post('alarm/set', 'AlarmController@set')->name('alarm.set')->middleware('auth');
Route::post('alarm/stop', 'AlarmController@stopAlarm')->name('alarm.stop')->middleware('auth');
Route::get('alarm/{user_id}/list', 'AlarmController@getAlarmList')->name('alarm.list')->middleware('auth');
Route::resource('sms', 'SmsController');
Route::resource('alarm', 'AlarmController')->middleware('auth');
Route::post('sms/stop', 'SmsController@stopSmsNotification')->name('sms.stop')->middleware('auth');
Route::get('sms/{user_id}/list', 'SmsController@getUnopenedSmsList')->name('sms.list')->middleware('auth');

app/Campaign.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

class Campaign extends Model
{
    protected $table = 'fptu_campaign';
    protected $fillable = array('name');

    public static function getIdByName($name)
    {
        $model = Campaign::where('name', $name)->first();
        if($model) {
            return $model->id;
        }else{
            return null;
        }
    }
}

app/Http/Controllers/CampaignController.php
<?php

namespace App\Http\Controllers;

use App\CampaignCategoryMapping;
use Illuminate\Http\Request;
use App\Campaign;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\DB;

class CampaignController extends Controller
{
    public function __construct()
    {
        $this->middleware('auth');
    }

    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $campaign_list = Campaign::select(
            'fptu_campaign.*',
            DB::raw("(SELECT GROUP_CONCAT(name) FROM fptu_campaign_category WHERE id IN (SELECT category_id FROM fptu_campaign_category_mapping WHERE campaign_id = fptu_campaign.id AND deleted_at IS NULL)) AS category_list")
        )->get();
        return view('campaign.index', ['campaign_list' => $campaign_list]);
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        return view('campaign.create');
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        $success = 0;
        $return_message = '';
        $found = Campaign::where('name', $request->name)
            ->count();
        $error = false;
        if ($found) {
            $return_message = 'Tên chiến dịch quảng cáo đã tồn tại.';
            $error = true;
        } else {
            $return_message = 'Tạo chiến dịch quảng cáo mới thành công!';
            $success = 1;
            $campaign = new Campaign();
            $campaign->name = trim($request->name);
            $saved = $campaign->save();
            if ($saved) {
                if(!empty($request->category)){
                    $campaignCategoryMapping = new CampaignCategoryMapping();
                    $campaignCategoryMapping->category_id = $request->category;
                    $campaignCategoryMapping->campaign_id = $campaign->id;
                    $campaignCategoryMapping->created_by = Auth::user()->id;
                    $campaignCategoryMapping->save();
                }
            }else{
                $return_message = 'Đã có lỗi trong quá trình lưu dữ liệu!';
                $success = 0;
                $error = true;
            }
        }
        $request->flash();
        if ($error) return view('campaign.create', ['success' => $success, 'message' => $return_message]);

        $category = CampaignCategoryMapping::whereNull("deleted_at")->where('campaign_id', $campaign->id)->first();
        return view('campaign.edit', ['campaign' => $campaign, 'category' => $category ,'success' => $success, 'message' => $return_message]);
    }


    /**
     * Show the form for editing the specified resource.
     *
     * @param  int $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        $campaign = Campaign::find($id);
        $category = CampaignCategoryMapping::whereNull("deleted_at")->where('campaign_id', $id)->first();

        return view('campaign.edit', ['campaign' => $campaign, 'category' => $category]);
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request $request
     * @param  int $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        $success = 0;
        $campaign = Campaign::find($id);
        $error = false;
        $return_message = '';

        if (!$error) {
            $update = array(
                'name' => $request->name
            );

            $updated = $campaign->update($update);
            if ($updated) {
                $return_message = 'Đã cập nhật dữ liệu thành công!';
                $success = 1;

                if(!empty($request->category)){
                    $categoryMapping = CampaignCategoryMapping::whereNull("deleted_at")
                        ->where('campaign_id', $campaign->id)
                        ->where('category_id', $request->category)
                        ->first();
                    if(!$categoryMapping){
                        CampaignCategoryMapping::whereNull("deleted_at")->where('campaign_id', $campaign->id)->delete();
                        $campaignCategoryMapping = new CampaignCategoryMapping();
                        $campaignCategoryMapping->category_id = $request->category;
                        $campaignCategoryMapping->campaign_id = $campaign->id;
                        $campaignCategoryMapping->created_by = Auth::user()->id;
                        $campaignCategoryMapping->save();

                    }
                }


            } else {
                $return_message = 'Đã có lỗi trong quá trình cập nhật dữ liệu.';
                $success = 0;
            }
        }
        //$user = User::find($id);
        $category = CampaignCategoryMapping::whereNull("deleted_at")->where('campaign_id', $id)->first();
        return view('campaign.edit', ['campaign' => $campaign, 'category' => $category, 'success' => $success, 'message' => $return_message]);
    }

    public function toggle($id)
    {
        $success = 0;
        $info_source = Campaign::find($id);
        $error = false;
        $return_message = '';
        $update = array();
        if ($info_source->hide == 1) {
            $info_source->hide = 0;
        } else {
            $info_source->hide = 1;
        }

        $updated = $info_source->save();
        if ($updated) {
            $return_message = 'Đã cập nhật trạng thái lớp thành công!';
            $success = 1;
        } else {
            $return_message = 'Đã có lỗi trong quá trình cập nhật dữ liệu.';
            $success = 0;
        }
        $info_source_list = array();
        $info_source_list = Campaign::all();
        return view('campaign.index', ['success' => $success, 'message' => $return_message, 'campaign_list' => $info_source_list]);
    }
}

resources/views/campaign/create.blade.php
@extends('layouts.main')

@section('content')

    <div class="container">
    <div class="row">
        <div class="col-md-8 col-md-offset-2">
            <div class="panel panel-default">
                <div class="panel-heading">Thêm campaign mới</div>
                <div class="panel-body">
                    @if(!empty($message))
                        <div class="alert {!! $success == 1?'alert-success':'alert-danger' !!}"
                             role="alert">{!! $message !!}</div>
                    @endif
                    <form class="form-horizontal" role="form" method="POST" action="{{ route('campaign.store') }}">
                        {{ csrf_field() }}

                        <div class="form-group{{ $errors->has('name') ? ' has-error' : '' }}">
                            <label for="name" class="col-md-4 control-label required">Tên campaign</label>

                            <div class="col-md-6">
                                <input id="name" type="text" class="form-control" name="name" value="{{ old('name') }}"
                                       required autofocus>
                                @if ($errors->has('name'))
                                    <span class="help-block">
                                        <strong>{{ $errors->first('name') }}</strong>
                                    </span>
                                @endif
                            </div>
                        </div>

                        <div class="form-group{{ $errors->has('category') ? ' has-error' : '' }}">
                            <label for="category" class="col-md-4 control-label">Loại</label>

                            <div class="col-md-6">
                                <select id="category" class="form-control" name="category">
                                    <?php echo \App\Utils::generateOptions(\App\CampaignCategory::listData(), old('category'), 'Chọn loại')?>
                                </select>
                                @if ($errors->has('category'))
                                    <span class="help-block">
                                        <strong>{{ $errors->first('category') }}</strong>
                                    </span>
                                @endif
                            </div>
                        </div>

                        <div class="form-group">
                            <div class="col-md-6 col-md-offset-4">
                                <button type="submit" class="btn btn-primary">
                                    Khởi tạo
                                </button>
                            </div>
                        </div>
                    </form>
                </div>
            </div>
        </div>
    </div>
</div>

    @stop

resources/views/campaign/edit.blade.php
@extends('layouts.main')

@section('content')

    <div class="container">
    <div class="row">
        <div class="col-md-8 col-md-offset-2">
            <div class="panel panel-default">
                <div class="panel-heading">Chỉnh sửa campaign</div>
                <div class="panel-body">
                    @if(!empty($message))
                        <div class="alert {!! $success == 1?'alert-success':'alert-danger' !!}"
                             role="alert">{!! $message !!}</div>
                    @endif
                    <form class="form-horizontal" role="form" method="POST"
                          action="{{ route('campaign.update', $campaign->id) }}">
                        {!! method_field('patch') !!}
                        {{ csrf_field() }}
                        <div class="form-group{{ $errors->has('name') ? ' has-error' : '' }}">
                            <label for="name" class="col-md-4 control-label">Tên campaign</label>

                            <div class="col-md-6">
                                <input id="name" type="text" class="form-control" name="name"
                                       value="{{ $campaign->name }}" required autofocus>

                                @if ($errors->has('name'))
                                    <span class="help-block">
                                        <strong>{{ $errors->first('name') }}</strong>
                                    </span>
                                @endif
                            </div>
                        </div>

                        <div class="form-group{{ $errors->has('category') ? ' has-error' : '' }}">
                            <label for="category" class="col-md-4 control-label">Loại</label>

                            <div class="col-md-6">
                                <select id="category" class="form-control" name="category">
                                    <?php echo \App\Utils::generateOptions(\App\CampaignCategory::listData(), !empty(old('category')) ? old('category') : (!empty($category) ? $category->category_id : ''), 'Chọn loại')?>
                                </select>
                                @if ($errors->has('category'))
                                    <span class="help-block">
                                        <strong>{{ $errors->first('category') }}</strong>
                                    </span>
                                @endif
                            </div>
                        </div>

                        <div class="form-group">
                            <div class="col-md-6 col-md-offset-4">
                                <button type="submit" class="btn btn-primary">
                                    Cập nhật
                                </button>
                            </div>
                        </div>
                    </form>
                </div>
            </div>
        </div>
    </div>
</div>

    @stop

resources/views/campaign/index.blade.php
@extends('layouts.main')

@section('content')

<div class="x_panel">
    <div class="x_title">
        <h2>Quản lý campaign</h2>
        <div class="pull-right">
            <a class="btn btn-default" href="{{ route('campaign.create') }}">Thêm campaign mới</a><br/>
        </div>
        <div class="clearfix"></div>
    </div>
    <div class="x_content">
        <table class="table table-hover">
            <thead>
            <th></th>
            <th></th>
            <th>Tên campaign</th>
            <th>Loại</th>
            </thead>
            <tbody>
            @foreach($campaign_list as $campaign)
                <tr>
                    <td><a href="{{ route('campaign.edit', $campaign->id) }}" title="Chỉnh sửa"><i
                                    class="fa fa-lg fa-pencil"
                                    aria-hidden="true"></i></a>
                    </td>
                    <td><a href="{{ route('campaign.toggle', $campaign->id) }}"
                           title="{!! $campaign->hide ?'Hiện' : 'Ẩn' !!}"><i
                                    class="fa fa-lg {!! $campaign->hide ?'fa-eye' : 'fa-eye-slash' !!}"
                                    aria-hidden="true"></i></a></td>
                    <td>{{ $campaign->name }}</td>
                    <td><?php echo str_replace(',','<br/>',$campaign->category_list)?></td>
                    <td>{!! $campaign->hide ?'<span class="class-status active">Ẩn</span>':'<span class="class-status inactive">Hiện</span>' !!}</td>
                </tr>
            @endforeach
            </tbody>
        </table>

    </div>

</div>

    @stop